function Controller() {
    var groups = {'Left': new Group(), 'Transfer': new Group(), 'Right': new Group()};
    var view = {};

    this.setView = function (_view) {
        view = _view;
        view.clearList();
        view.on('groupLoad', onGroupLoad);
        view.on('addition', onAddition);
        view.on('deletion', onDeletion);
        view.on('transfer', onTransfer);
    };

    var onGroupLoad = function (type, groupID, semesterID) {
        $.post(URLdir + 'handler/Students/getByGroup/',
            {
                studyGroupID: groupID,
                semesterID: semesterID
            },
            function (data) {
                groups[type].clear();
                groups[type].setList(data);
                view.fillList(type, data);
            }, 'json');
    };

    var onTransfer = function (groupID, semesterID) {
        if (groupID != -1) {

            $.post(URLdir + 'handler/Students/transfer/',
                {
                    studyGroupID: groupID,
                    semesterID: semesterID,
                    transferList: JSON.stringify(groups.Transfer.getIDs())
                },
                function (data) {
                    EventInspector.success('Студенты успешно переведены');
                    groups['Transfer'].clear();
                    groups['Right'].setList(data);
                    view.fillList('Right', data);
                    view.clearList('Transfer');
                }, 'json');
        }
        else {
            EventInspector.error('Не выбрана группа для перевода');
        }
    };

    var onAddition = function (from, to, listStudentsID) {
        listStudentsID.forEach(function (elem) {
            var student = groups[from].peek(+elem.itemID);
            student.transfered = !(student.transfered);
            groups[to].push(student);
        });
        view.clearSelection(from, listStudentsID);
        view.addChecked(to, listStudentsID);
    };

    var onDeletion = function (from, listStudentsID) {
        listStudentsID.forEach(function (elem) {
            groups[from].pop(+elem.itemID);
        });
        view.clearChecked(from, listStudentsID);
    };
}
